#ifndef _MatlabHook_h
#define _MatlabHook_h 1

/**************************************************************************
Version identification:
@(#)MatlabHook.h	1.2	07/25/97
 
Copyright (c) 1990-1997 The Regents of the University of California.
All rights reserved.
 
Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the
above copyright notice and the following two paragraphs appear in all
copies of this software.
 
IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
 
THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.
 
                                                PT_COPYRIGHT_VERSION_2
 
 Programmer:  Guy Maor
 Date of creation: 7/24/97
 Revisions:
 
 Hook code for the Ptolemy interface to Matlab.

 This class is linked with the matlab shared libraries to create
 libptmatlab.so.  Ptolemy will try to load this library in when it
 instantiates MatlabIfc.  Linker will then call the ctor for the
 static object MatlabHook::Me.

 In MatlabIfc are function pointers to all the matlab functions.  The
 ctor for MatlabHook points those at the actual matlab functions.
 There also exist dummy functions in MatlabIfc for each of the matlab
 functions.  These functions merely return an error; MatlabIfc will
 point its function pointers at the dummies if it is unable to load
 libptmatlab.so.

 Because the code to declare all the function pointers, dummy
 functions, and pointer assignments is hard to maintain, it is
 generated by src/utils/libexttools/MatlabIfcGen.tcl.

 **************************************************************************/

#ifdef __GNUG__
#pragma interface
#endif

class MatlabHook {
public:
  MatlabHook ();
  static MatlabHook Me;
};

#endif
